{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, System.ComponentModel, Borland.Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.nfm}

type
 TClasseMere = class
  Fint : integer;
  const test = 357;
  type TTypeImbrique = class
   procedure Bonjour;
  end;
  procedure Bonsoir;
  end;

procedure TClasseMere.Bonsoir;
begin
 Showmessage('Bonsoir ! (depuis classe mre)');
end;

procedure TClasseMere.TTypeImbrique.Bonjour;
begin
 Showmessage('Bonjour ! (depuis classe imbrique)');
end;

procedure TForm1.Button1Click(Sender: TObject);
var M : TClasseMere; I:TClasseMere.TTypeImbrique;
begin
 M := TClasseMere.Create;
 M.Fint := 888;
 M.Bonsoir;
 I := TClasseMere.TTypeImbrique.Create;
 I.Bonjour;
 Showmessage('Constante: '+InttoStr(M.test));
end;

end.
